Index: vtcross/branches/bhilburn/include/libvtcross.h
===================================================================
--- vtcross/branches/bhilburn/include/libvtcross.h	(revision 108)
+++ 	(revision )
@@ -1,107 +1,0 @@
-/* Virginia Tech Cognitive Radio Open Source Systems
- * Virginia Tech, 2009
- *
- * LICENSE INFORMATION GOES HERE
- */
-
-/* VTCROSS Cognitive Radio API
- *
- * This header exports all public functions that comprise the VTCROSS function
- * library.  
- *
- * PUT MORE STUFF HERE
- */
-
-#ifdef GCC_EXPERIMENTAL
-    #include <cstdint>
-#else
-    #include <stdint.h>
-#endif
-
-#include "components.h"
-#include "containers.h"
-
-
-/* Parses VTCROSS XML configuration file and uses it to configure the radio. 
- *
- * This function *must* be called when the radio first starts up, and may be
- * called at any point after that to reconfigure the radio.
- */
-bool ParseRadioConfiguration();
-
-/* Lists current radio configuration options loaded from the configuration XML
- * file. 
- *
- * TODO How are we listing these?  Are we simply returning them to stdout?
- * Logging them? Returning strings?  Need to figure this out...
- */
-void ListCurrentRadioConfiguration();
-
-/* View data from the current status of the radio. 
- *
- * This function allows client code to capture radio properties at any certain
- * instant.  Note, however, that these properties could be changing at very
- * rapid rates. There is no guarantee that the return results from these
- * functions will still be valid by the time the client code receives them.
- */
-Observables* GetRadioObservables();
-Parameters* GetRadioParameters();
-Utilities* GetRadioUtilities();
-
-/* View components currently connected to the radio by id. 
- *
- * TODO Should there be another way to list components? If you have 10 cognitive
- * engines, how are you going to know which is which just by id?
- */
-uint32_t* GetConnectedCognitiveEngines();
-uint32_t* GetConnectedPolicyEngines();
-uint32_t* GetConnectedManagementServiceLayers();
-uint32_t* GetConnectedComponents();
-
-/* Look up component information by id. 
- *
- * Note that the return type is of abstract base class component, which can then
- * be used to reference whatever sub-component type was referenced by the id.
- */
-Component* GetComponentInformation(uint32_t id);
-
-/* Given a certain set of observables, ask the radio to find the optimum radio
- * parameters and return them. 
- *
- * TODO I'm a little confused about this function... why would anyone need to
- * use this?  Shouldn't this be internal to the radio operation? 
- */
-Parameters* GetOptimalParameters(Observables *radioObservables);
-
-/* Update the radio regarding its performance for a certain set of transmission
- * parameters, observables, and utilities.
- *
- * TODO Where in the function parameters are we accurately representing the
- * radio's performance?
- */
-bool UpdateParameterPerformance(Parameters *radioParameters, \
-        Observables *radioObservables, Utilies *radioUtilies);
-
-/* Deactivate/Activate/Disconnect a component by id.
- *
- * TODO This seems silly?  If id's are independent of component type, why not
- * just have one deactivate function that takes an id and operates on it? Why do
- * we need 3 separate functions? They are all components...
- */
-bool DeactivateCE(uint32_t id);
-bool DeactivatePE(uint32_t id);
-bool DeactivateSML(uint32_t id);
-bool ActivateCE(uint32_t id);
-bool ActivatePE(uint32_t id);
-bool ActivateSML(uint32_t id);
-bool DisconnectCE(uint32_t id);
-bool DisconnectPE(uint32_t id);
-bool DisconnectSML(uint32_t id);
-
-/* Shut down the radio.
- *
- * This function will deactivate and disconnect all radio components before
- * finally shutting down the shell and stopping radio operations.
- */
-bool Shutdown();
-
Index: vtcross/branches/bhilburn/include/components.h
===================================================================
--- vtcross/branches/bhilburn/include/components.h	(revision 104)
+++ 	(revision )
@@ -1,73 +1,0 @@
-/* Virginia Tech Cognitive Radio Open Source Systems
- * Virginia Tech, 2009
- *
- * LICENSE INFORMATION GOES HERE
- */
-
- /* This header exports the declarations for all VT-CROSS radio components.  It
- * contains two pure abstract base classes, Component and Engine; Engine derives
- * from Component.  All functions contained within the abstract base classes are
- * dynamically linked and pure, and all child non-abstract classes derive using 
- * private inheritence.  Class functions of the abstract base classes are public
- * for two reasons: (1) To allow for public/protected inheritence in other 
- * implementations, (2) So that symbolic debuggers can navigate the call tree 
- * for typecasted objects of derivative classes.
- */
-
-
-#include "containers.h"
-
-
-class Component
-{
-    public:
-        virtual void GetRemoteComponentType() = 0;
-        virtual void WaitForSignal() = 0;
-        virtual void Shutdown() = 0;
-        virtual void Reset() = 0;
-        virtual void RegisterComponent(socketFD, compType) = 0;
-        virtual void DeregisterComponent() = 0;
-};
-
-
-class Engine : public Component
-{
-    public:
-        virtual void RegisterServices() = 0;
-        virtual void DeregisterServices() = 0;
-};
-
-
-class ServiceManagementLayer : private Component
-{
-    private: 
-        void TransferRadioConfiguration();
-        void TransferExperience();
-        void ReceiveServices();
-        void SetActiveMission();
-        void ListServices();
-        void ReloadConfiguration();
-        void LoadConfiguration();
-};
-
-
-class PolicyEngine : private Engine
-{
-    private:
-        void ReloadPolicies();
-        void LoadPolicies();
-        void ValidateParameters();
-};
-
-
-class CognitiveEngine : private Engine
-{
-    private:
-        void ReceiveRadioConfiguration();
-        void ReceiveExperience();
-        void GetSolution(Observable *observables);
-        void GetSolution(Observable *observables, string service);
-        void ReceiveFeedback(Observable *observables, Parameter *parameters, Utility *utilities);
-        void ReceiveFeedback(Observable *observables, Parameter *parameters, string service);
-};
-
Index: vtcross/branches/bhilburn/include/containers.h
===================================================================
--- vtcross/branches/bhilburn/include/containers.h	(revision 104)
+++ 	(revision )
@@ -1,62 +1,0 @@
-/* Virginia Tech Cognitive Radio Open Source Systems
- * Virginia Tech, 2009
- *
- * LICENSE INFORMATION GOES HERE
- */
-
-/* This header contains commonly used data container structs in VT-CROSS
- * systems.
- */
-
-
-/* Until the new C++ i99 standard is made permanent, allow use of otherwise
- * legacy C-libraries.
- */
-#ifdef GCC_EXPERIMENTAL
-    #include <cstdint>
-#else
-    #include <stdint.h>
-#endif
-
-
-struct CE_Info {
-    uint32_t numUtilities;
-    uint32_t numParameters;
-    uint32_t numObservables;
-    uint32_t policy_engine;
-    uint32_t policy_socket;
-    uint32_t ce_socket;
-};
-
-struct Utility {
-    std::string name;
-    std::string units;
-    std::string goal;
-    float target;
-    float value;
-};
-
-struct Affect {
-    Utility *u;
-    std::string relation;
-};
-
-struct Parameter {
-    std::string name;
-    std::string units;
-    float min;
-    uint32_t numAffects;
-    Affect affection_list[10];
-    float max;
-    float step;
-    float value;
-};
-
-struct Observable {
-    std::string name;
-    Affect affection_list[10];
-    uint32_t numAffects;
-    float value;
-};
-
-
Index: vtcross/branches/bhilburn/include/cbr.h
===================================================================
--- vtcross/branches/bhilburn/include/cbr.h	(revision 105)
+++ 	(revision )
@@ -1,30 +1,0 @@
-//
-// Case-based reasoner
-//
-
-#include "sqlite3.h"
-//#define CBR_LEN_FILENAME 64
-
-#define DATABASENAME "cactus_cbr"
-
-typedef struct cbr_s * cbr;
-
-// create the CBR
-cbr cbr_create(char * _filename, char * _tablename, char * _cols[], unsigned int _len);
-
-// free the CBR
-void cbr_free(cbr _cbr);
-
-// print databse/table
-void cbr_print(cbr _cbr);
-
-#define EQ 0    // equals
-#define NE 1    // not equals
-#define GT 2    // greater than
-#define GE 3    // greater than or equal to
-#define LT 4    // less than
-#define LE 5    // less than or equal to
-int cbr_search(cbr _cbr, char *_names[], int * _ops, float *_vals, unsigned int _n, float *_retvals);
-
-int cbr_add_row(cbr _cbr, char *_cols[], float *_vals, unsigned int _len);
-