Index: vtcross/branches/bhilburn/configure.ac
===================================================================
--- vtcross/branches/bhilburn/configure.ac	(revision 133)
+++ vtcross/branches/bhilburn/configure.ac	(revision 136)
@@ -1,4 +1,5 @@
 AC_INIT([vtcross], [0.0.0])
-AM_INIT_AUTOMAKE(vtcross, 0.0.0)
+AM_INIT_AUTOMAKE([vtcross], [0.0.0])
+AM_CONFIG_HEADER([src/include/vtcross/config.]h)
 
 AC_CONFIG_MACRO_DIR([m4])
Index: vtcross/branches/bhilburn/.gitignore
===================================================================
--- vtcross/branches/bhilburn/.gitignore	(revision 131)
+++ vtcross/branches/bhilburn/.gitignore	(revision 136)
@@ -18,6 +18,6 @@
 config.sub
 configure
-src/include/config.h
-src/include/stamp-h1
+src/include/vtcross/config.h
+src/include/vtcross/stamp-h1
 install-sh
 libtool
@@ -27,4 +27,5 @@
 autom4te.cache/*
 m4/*
+*.in
 
 \.*
Index: vtcross/branches/bhilburn/src/cognitive_engines/cbr.c
===================================================================
--- vtcross/branches/bhilburn/src/cognitive_engines/cbr.c	(revision 130)
+++ vtcross/branches/bhilburn/src/cognitive_engines/cbr.c	(revision 136)
@@ -8,4 +8,5 @@
 
 #include "vtcross/cbr.h"
+#include "vtcross/common.h"
 
 
Index: vtcross/branches/bhilburn/src/cognitive_engines/cbr_demo.c
===================================================================
--- vtcross/branches/bhilburn/src/cognitive_engines/cbr_demo.c	(revision 130)
+++ vtcross/branches/bhilburn/src/cognitive_engines/cbr_demo.c	(revision 136)
@@ -11,4 +11,5 @@
 
 #include "vtcross/cbr.h"
+#include "vtcross/common.h"
 
 //using namespace std;
Index: vtcross/branches/bhilburn/src/include/vtcross/Makefile.am
===================================================================
--- vtcross/branches/bhilburn/src/include/vtcross/Makefile.am	(revision 125)
+++ vtcross/branches/bhilburn/src/include/vtcross/Makefile.am	(revision 136)
@@ -1,1 +1,1 @@
-include_HEADERS = cbr.h components.h containers.h libvtcross.h
+include_HEADERS = cbr.h components.h containers.h libvtcross.h common.h config.h
Index: vtcross/branches/bhilburn/src/include/vtcross/common.h
===================================================================
--- vtcross/branches/bhilburn/src/include/vtcross/common.h	(revision 136)
+++ vtcross/branches/bhilburn/src/include/vtcross/common.h	(revision 136)
@@ -0,0 +1,18 @@
+/* Virginia Tech Cognitive Radio Open Source Systems
+ * Virginia Tech, 2009
+ *
+ * LICENSE INFORMATION GOES HERE
+ */
+
+/* This file is included in every source file of the VTCROSS system.  It
+ * declares global flags and includes.
+ */
+
+#ifndef COMMON_H
+#define COMMON_H
+
+#ifdef HAVE_CONFIG_H
+    #include "config.h"
+#endif
+
+#endif
Index: vtcross/branches/bhilburn/src/policy_engines/default_policy_engine.cpp
===================================================================
--- vtcross/branches/bhilburn/src/policy_engines/default_policy_engine.cpp	(revision 129)
+++ vtcross/branches/bhilburn/src/policy_engines/default_policy_engine.cpp	(revision 136)
@@ -10,4 +10,5 @@
 #include "vtcross/cbr.h"
 #include "vtcross/containers.h"
+#include "vtcross/common.h"
 
 
Index: vtcross/branches/bhilburn/src/shell/cr_shell.cpp
===================================================================
--- vtcross/branches/bhilburn/src/shell/cr_shell.cpp	(revision 131)
+++ vtcross/branches/bhilburn/src/shell/cr_shell.cpp	(revision 136)
@@ -14,4 +14,5 @@
 
 #include "vtcross/containers.h"
+#include "vtcross/common.h"
 #include "tinyxml.h"
 #include "tinystr.h"
Index: vtcross/branches/bhilburn/src/libvtcross/libvtcross.cpp
===================================================================
--- vtcross/branches/bhilburn/src/libvtcross/libvtcross.cpp	(revision 112)
+++ vtcross/branches/bhilburn/src/libvtcross/libvtcross.cpp	(revision 136)
@@ -11,4 +11,5 @@
  */
 
-#include "libvtcross.h"
+#include "vtcross/libvtcross.h"
+#include "vtcross/common.h"
 
Index: vtcross/branches/bhilburn/reconf
===================================================================
--- vtcross/branches/bhilburn/reconf	(revision 119)
+++ vtcross/branches/bhilburn/reconf	(revision 136)
@@ -4,3 +4,4 @@
 aclocal && \
 autoconf && \
+autoheader && \
 automake --add-missing