Index: vtcross/trunk/src/shell/cr_shell.cpp
===================================================================
--- vtcross/trunk/src/shell/cr_shell.cpp	(revision 166)
+++ vtcross/trunk/src/shell/cr_shell.cpp	(revision 167)
@@ -224,5 +224,5 @@
     if (n < 0)
         error("ERROR reading from socket");
-    //    print32_tf("ReadMessage:%s %d\n",buffer,n);
+    //    printf("ReadMessage:%s %d\n",buffer,n);
 
     return n;
@@ -241,7 +241,7 @@
         error("Error sending to client\n");
     if(n == 0)
-        print32_tf("Client closed the socket.\n");
-
-	//print32_tf("SendMessage:%s %d\n",message.c_str(),n);	
+        printtf("Client closed the socket.\n");
+
+	//printf("SendMessage:%s %d\n",message.c_str(),n);	
     return n;
 }
@@ -255,9 +255,9 @@
 	//int32_t total_bytes;   
 
-	print32_tf("Cognitive Radio:: Sending Radio Operating Profile to Cognitive Engine.\n\n");
+	printtf("Cognitive Radio:: Sending Radio Operating Profile to Cognitive Engine.\n\n");
  
  	// utilities
 	// Send number of utilities
-	sprint32_tf(counter,"%d",ce_info->numUtilities);
+	sprintf(counter,"%d",ce_info->numUtilities);
 	SendMessage(socketfd,counter);
 	// send utility	
@@ -266,22 +266,22 @@
 		SendMessage(socketfd,uList[i]->units);
 		SendMessage(socketfd,uList[i]->goal);
-		sprint32_tf(var,"%f",uList[i]->target);
+		sprintf(var,"%f",uList[i]->target);
 		SendMessage(socketfd,var);
 	}
 
 	// parameters
-    sprint32_tf(counter,"%i",ce_info->numParameters);
+    sprintf(counter,"%i",ce_info->numParameters);
 	SendMessage(socketfd,counter);
 	for(i = 0; i < ce_info->numParameters; i++) {
 		SendMessage(socketfd,pList[i]->name);
 		SendMessage(socketfd,pList[i]->units);
-		sprint32_tf(var,"%f",pList[i]->min);
-		SendMessage(socketfd,var);
-		sprint32_tf(var,"%f",pList[i]->max);
-		SendMessage(socketfd,var);
-		sprint32_tf(var,"%f",pList[i]->step);
+		sprintf(var,"%f",pList[i]->min);
+		SendMessage(socketfd,var);
+		sprintf(var,"%f",pList[i]->max);
+		SendMessage(socketfd,var);
+		sprintf(var,"%f",pList[i]->step);
 		SendMessage(socketfd,var);
 		
-		sprint32_tf(counter,"%i",pList[i]->numAffects); 
+		sprintf(counter,"%i",pList[i]->numAffects); 
 		SendMessage(socketfd,counter);
 		for(j = 0; j < pList[i]->numAffects; j++) {
@@ -292,10 +292,10 @@
 
     // observables
-	sprint32_tf(counter,"%i",ce_info->numObservables);
+	sprintf(counter,"%i",ce_info->numObservables);
 	SendMessage(socketfd,counter);
 	for(i = 0; i < ce_info->numObservables; i++) {
 		SendMessage(socketfd,oList[i]->name);
 		
-		sprint32_tf(counter,"%i",oList[i]->numAffects); 
+		sprintf(counter,"%i",oList[i]->numAffects); 
 		SendMessage(socketfd,counter);
 		for(j = 0; j < oList[i]->numAffects; j++) {
@@ -309,7 +309,7 @@
         string message;
 	n = ReceiveMessage(socketfd, buffer);
-    //print32_tf("%s\n", buffer);
+    //printf("%s\n", buffer);
         //cout << message << endl;
-	//print32_tf("ACK received.\n");
+	//printf("ACK received.\n");
 
 }
@@ -332,20 +332,20 @@
     for (i = 0; i < num_rows; i++){
         for (j = 0; j< num_cols; j++){
-		sprint32_tf(var,"%f",past_exp[i][j]);
-        //print32_tf("%f, \n", past_exp[i][j]);
-        //print32_tf("%s, \n", var);
+		sprintf(var,"%f",past_exp[i][j]);
+        //printf("%f, \n", past_exp[i][j]);
+        //printf("%s, \n", var);
         }
     }
     
     // send the number of rows to the ce first
-	sprint32_tf(counter,"%d",num_rows);
+	sprintf(counter,"%d",num_rows);
 	SendMessage(socketfd,counter);
     // send the number of columns to the ce
-	sprint32_tf(counter,"%d",num_cols);
+	sprintf(counter,"%d",num_cols);
 	SendMessage(socketfd,counter);
     // update ce with experience
     for (i = 0; i < num_rows; i++){
         for (j = 0; j< num_cols; j++){
-		sprint32_tf(var,"%f",past_exp[i][j]);
+		sprintf(var,"%f",past_exp[i][j]);
 		SendMessage(socketfd,var);
         }
@@ -378,19 +378,19 @@
 	SendMessage(socketfd,control_msg);
 
-    print32_tf("Cognitive Radio:: Here. %i\n\n", socketfd);
+    printf("Cognitive Radio:: Here. %i\n\n", socketfd);
 
 	// Send parameter information 
-    sprint32_tf(counter,"%i",ce_info->numParameters);
+    sprintf(counter,"%i",ce_info->numParameters);
 	SendMessage(socketfd,counter);
 	for(i = 0; i < ce_info->numParameters; i++) {
 		SendMessage(socketfd,pList[i]->name);
 		SendMessage(socketfd,pList[i]->units);
-		sprint32_tf(var,"%f",pList[i]->min);
-		SendMessage(socketfd,var);
-		sprint32_tf(var,"%f",pList[i]->max);
-		SendMessage(socketfd,var);
-		sprint32_tf(var,"%f",pList[i]->step);
-		SendMessage(socketfd,var);
-		sprint32_tf(var,"%f",pList[i]->value);
+		sprintf(var,"%f",pList[i]->min);
+		SendMessage(socketfd,var);
+		sprintf(var,"%f",pList[i]->max);
+		SendMessage(socketfd,var);
+		sprintf(var,"%f",pList[i]->step);
+		SendMessage(socketfd,var);
+		sprintf(var,"%f",pList[i]->value);
 		SendMessage(socketfd,var);
 		
@@ -429,8 +429,8 @@
     if(ce_info->policy_engine == 1) {
 
-        print32_tf("Cognitive Radio:: Found Policy Engine!\n");
-        print32_tf("Cognitive Radio:: Validating parameters with Policy Engine\n\n");
+        printf("Cognitive Radio:: Found Policy Engine!\n");
+        printf("Cognitive Radio:: Validating parameters with Policy Engine\n\n");
         RequestPolicyValidation(pList,ce_info); 
-        print32_tf("Cognitive Radio:: Done\n\n");
+        printf("Cognitive Radio:: Done\n\n");
 
     }
@@ -503,5 +503,5 @@
 
 	// update ce with experience
-    print32_tf("Cognitive Radio:: Sending Previous Experience to New Cognitive Engine.\n\n");
+    printf("Cognitive Radio:: Sending Previous Experience to New Cognitive Engine.\n\n");
     UpdateCEExperience(socketfd, num_rows, num_cols, past_exp);	
 
@@ -526,5 +526,5 @@
     /* clntSock is connected to a client! */
     
-    print32_tf("Handling client %s\n", inet_ntoa(echoClntAddr.sin_addr));
+    printf("Handling client %s\n", inet_ntoa(echoClntAddr.sin_addr));
 
     return clntSock;
@@ -552,5 +552,5 @@
     /* Mark the socket so it will listen for incoming connections */
     if (listen(sock, 5) < 0) {
-        print32_tf("listen() failed\n");
+        printf("listen() failed\n");
         return 0;
     }
@@ -567,5 +567,5 @@
     ReceiveMessage(socketfd,buffer);
 
-    print32_tf("Cognitive Radio:: Message Received - %s.\n\n", buffer);
+    printf("Cognitive Radio:: Message Received - %s.\n\n", buffer);
 
     if(strcmp(buffer,"c_register") == 0) 
@@ -636,5 +636,5 @@
     }
     
-    print32_tf("Starting server:  Hit return to shutdown\n");
+    printf("Starting server:  Hit return to shutdown\n");
     while (running)
     {
@@ -655,10 +655,10 @@
         rc = select(maxDescriptor + 1, &sockSet, NULL, NULL, &selTimeout); 
         if (rc == 0)
-            print32_tf("No echo requests for %i secs...Server still alive\n", timeout);
+            printf("No echo requests for %i secs...Server still alive\n", timeout);
         else 
         {
             if (FD_ISSET(0, &sockSet)) /* Check keyboard */
             {
-                print32_tf("Shutting down server\n");
+                printf("Shutting down server\n");
                 getchar();
                 running = 0;
@@ -670,5 +670,5 @@
                 if (FD_ISSET(port, &sockSet))
                 {
-                    print32_tf("Request on port %d:  ", port);
+                    printf("Request on port %d:  ", port);
 	                desc_ready -= 1;
 
@@ -688,9 +688,9 @@
                             if(new_sd > maxDescriptor) 
                                 maxDescriptor = new_sd;
-                            print32_tf("New incoming connection - %i\n\n",new_sd);
+                            printf("New incoming connection - %i\n\n",new_sd);
                         } while(new_sd != -1);
                     } else {
                         
-                        print32_tf("Request on already open descriptor.\n\n");
+                        printf("Request on already open descriptor.\n\n");
                         HandleTCPClient(port, uList, pList, oList, ce_info);
 
@@ -751,5 +751,5 @@
 	cout << "Initialize:: Configuration file parsing completed.\n" << endl;
 
-    //print32_t_current_config(uList, pList, oList, &ce_info);
+    //print_current_config(uList, pList, oList, &ce_info);
 	
    StartServers(uList, pList, oList, ce_info);