Index: vtcross/trunk/src/include/vtcross/libvtcross.h
===================================================================
--- vtcross/trunk/src/include/vtcross/libvtcross.h	(revision 161)
+++ vtcross/trunk/src/include/vtcross/libvtcross.h	(revision 170)
@@ -33,4 +33,5 @@
 bool ParseRadioConfiguration();
 
+
 /* Lists current radio configuration options loaded from the configuration XML
  * file. 
@@ -40,4 +41,5 @@
  */
 void ListCurrentRadioConfiguration();
+
 
 /* View data from the current status of the radio. 
@@ -52,4 +54,5 @@
 Utilities* GetRadioUtilities();
 
+
 /* View components currently connected to the radio by id. 
  *
@@ -62,4 +65,5 @@
 uint32_t* GetConnectedComponents();
 
+
 /* Look up component information by id. 
  *
@@ -68,4 +72,5 @@
  */
 Component* GetComponentInformation(uint32_t id);
+
 
 /* Given a certain set of observables, ask the radio to find the optimum radio
@@ -77,4 +82,5 @@
 Parameters* GetOptimalParameters(Observables *radioObservables);
 
+
 /* Update the radio regarding its performance for a certain set of transmission
  * parameters, observables, and utilities.
@@ -85,4 +91,5 @@
 bool UpdateParameterPerformance(Parameters *radioParameters, \
         Observables *radioObservables, Utilies *radioUtilies);
+
 
 /* Deactivate/Activate/Disconnect a component by id.
@@ -102,4 +109,5 @@
 bool DisconnectSML(uint32_t id);
 
+
 /* Shut down the radio.
  *
Index: vtcross/trunk/src/include/vtcross/socketcomm.h
===================================================================
--- vtcross/trunk/src/include/vtcross/socketcomm.h	(revision 161)
+++ vtcross/trunk/src/include/vtcross/socketcomm.h	(revision 170)
@@ -14,9 +14,27 @@
 
 
+/* TODO
+ */
 void ReadMessage(int32_t socketFD, char* msgBuffer);
+
+
+/* TODO
+ */
 int32_t ClientSocket(char* serverName, char* portNumber);
+
+
+/* TODO
+ */
 int32_t SendMessage(int32_t socketFD, char* message);
+
+
+/* TODO
+ */
 int32_t GetParameter(int32_t socketFD, struct Parameter pList[], \
         struct CE_Info *ce_info);
+
+
+/* TODO
+ */
 int32_t GetRequest(int32_t socketFD, struct Parameter pList[], \
         struct CE_Info *ce_info);
Index: vtcross/trunk/src/include/vtcross/components.h
===================================================================
--- vtcross/trunk/src/include/vtcross/components.h	(revision 161)
+++ vtcross/trunk/src/include/vtcross/components.h	(revision 170)
@@ -24,11 +24,36 @@
 
 
+/* Component abstract base class that all component classes should inherit from,
+ * including cognitive and policy engines, and the service management layer.
+ * Defines only functions required by all component types.
+ */
 class Component
 {
     public:
+        /* Asks the component at the passed socket FD for its component type
+         * string.
+         */
         virtual void GetRemoteComponentType(int32_t socketFD) = 0;
+
+
+        /* Wait for a command signal containing task instructions.
+         */
         virtual void WaitForSignal(int32_t socketFD) = 0;
+
+
+        /* Completely shutdown the radio and all operations.
+         */
         virtual void Shutdown() = 0;
+
+
+        /* Reset the radio and reload all configuration files.
+         *
+         * TODO are we remembering experiences in CEs?
+         */
         virtual void Reset() = 0;
+
+
+        /* Register or deregister a component with the primary radio shell.
+         */
         virtual void RegisterComponent(int32_t socketFD) = 0;
         virtual void DeregisterComponent(int32_t socketFD) = 0;
@@ -36,7 +61,14 @@
 
 
+/* Engine abstract base class from which all engine component types should
+ * inherit (e.g. cognitive and policy engines). Inherits all functions from the
+ * ABC Component publically.
+ */
 class Engine : public Component
 {
     public:
+        /* Register or deregister services that this engine provides with the
+         * service management layer.
+         */
         virtual void RegisterServices(int32_t socketFD) = 0;
         virtual void DeregisterServices(int32_t socketFD) = 0;
@@ -44,4 +76,8 @@
 
 
+/* Service Management Layer (SML) class declaration.  The functions listed here
+ * are required by the VTCROSS API for service-oriented VTCROSS radio
+ * architectures.
+ */
 class ServiceManagementLayer : public Component
 {
@@ -58,9 +94,34 @@
 
     private: 
+        /* Receive the radio configuration settings from the shell and pass them
+         * on to another component.
+         */
         void TransferRadioConfiguration();
+
+        
+        /* Receive information regarding a completed 'experience' and pass it on
+         * to the appropriate cognitive engine.
+         */
         void TransferExperience();
+
+        
+        /* Listen for other components registering their available services with
+         * the SML. */
         void ReceiveServices();
+
+
+        /* Change the active mission of the radio to a new one and adjust radio
+         * behavoir appropriately.
+         */
         void SetActiveMission();
+
+
+        /* List all services provided to the radio by registered components.
+         */
         void ListServices();
+
+
+        /* Load/Relead the XML configuration file. 
+         */
         void ReloadConfiguration();
         void LoadConfiguration();
@@ -68,4 +129,7 @@
 
 
+/* Policy Engine class declaration.  All public functions are inherited from
+ * parent classes.
+ */
 class PolicyEngine : public Engine
 {
@@ -85,8 +149,19 @@
 
     private:
+        /* Parse and load/reload policies into the policy engine.
+         */
         void LoadPolicies();
         void ReloadPolicies();
+
+        
+        /* Return a decision made by the policy engine regarding a certain set
+         * of transmission parameters.
+         */
         void SendPEDecision(int32_t socketFD, struct Parameter pList[], \
                 struct CE_Info *ce_info, int32_t decision_array[]);
+
+
+        /* Validate a set of transmission parameters received from the radio.
+         */
         void ValidateParameters(struct Parameter pList[], \
                 struct CE_Info *ce_info, int decision_array[]);
@@ -94,4 +169,7 @@
 
 
+/* Cognitive Engine class declaration.  All public functions are inherited from
+ * parent classes.
+ */
 class CognitiveEngine : public Engine
 {
@@ -111,8 +189,29 @@
 
     private:
+        /* Receive the transmitted radio configuration from the radio itself
+         * (the CE will not always be local to the radio).
+         */
         void ReceiveRadioConfiguration(int32_t socketFD);
+
+
+        /* Receive an 'experience' report from the radio.
+         */
         void ReceiveExperience(int32_t socketFD);
+
+
+        /* Find the most optimal set of transmission parameters given certain
+         * observables and possibly a service if the SML component is present
+         * and active.
+         */
         void GetSolution(Observable *observables);
         void GetSolution(Observable *observables, std::string service);
+
+
+        /* Receive a feedback from the radio regarding the performance of a
+         * certain set of parameters, possibly associated with a service.
+         *
+         * TODO what is the difference between experiences and feedback,
+         * exactly? we should explain that explicitly here.
+         */
         void ReceiveFeedback(Observable *observables,\
                 Parameter *parameters, Utility *utilities);
Index: vtcross/trunk/src/include/vtcross/containers.h
===================================================================
--- vtcross/trunk/src/include/vtcross/containers.h	(revision 165)
+++ vtcross/trunk/src/include/vtcross/containers.h	(revision 170)
@@ -17,4 +17,12 @@
 
 
+/* TODO initially made all of the string fields std::strings, but this might not
+ * be the best end-decision. Need to evaluate our needs and figure out if
+ * cstrings would do better for us. */
+
+
+/* TODO
+ *
+ */
 struct CE_Info {
     uint32_t numUtilities;
@@ -26,4 +34,8 @@
 };
 
+
+/* TODO
+ *
+ */
 struct Utility {
     std::string name;
@@ -34,4 +46,8 @@
 };
 
+
+/* TODO
+ *
+ */
 struct Affect {
     Utility *u;
@@ -39,4 +55,8 @@
 };
 
+
+/* TODO
+ *
+ */
 struct Parameter {
     std::string name;
@@ -50,4 +70,8 @@
 };
 
+
+/* TODO
+ *
+ */
 struct Observable {
     std::string name;
Index: vtcross/trunk/src/include/vtcross/cbr.h
===================================================================
--- vtcross/trunk/src/include/vtcross/cbr.h	(revision 161)
+++ vtcross/trunk/src/include/vtcross/cbr.h	(revision 170)
@@ -2,4 +2,6 @@
 // Case-based reasoner
 //
+//
+// TODO REDO THIS FILE
 
 #ifndef CBR_H