Index: vtcross/trunk/src/include/vtcross/socketcomm.h
===================================================================
--- vtcross/trunk/src/include/vtcross/socketcomm.h	(revision 187)
+++ vtcross/trunk/src/include/vtcross/socketcomm.h	(revision 195)
@@ -30,5 +30,5 @@
  */
 int32_t GetParameter(int32_t socketFD, struct Parameter pList[], \
-        struct CE_Info *ce_info);
+        struct Radio_Info *radio_info);
 
 
@@ -36,5 +36,5 @@
  */
 int32_t GetRequest(int32_t socketFD, struct Parameter pList[], \
-        struct CE_Info *ce_info);
+        struct Radio_Info *radio_info);
 
 
@@ -58,5 +58,5 @@
  */
 void HandleTCPClient(int32_t socketfd, Utility* uList[], Parameter* pList[], \
-        Observable* oList[], CE_Info* ce_info);
+        Observable* oList[], Radio_Info* radio_info);
 
 #endif
Index: vtcross/trunk/src/include/vtcross/components.h
===================================================================
--- vtcross/trunk/src/include/vtcross/components.h	(revision 194)
+++ vtcross/trunk/src/include/vtcross/components.h	(revision 195)
@@ -205,5 +205,5 @@
          * of transmission parameters.
          */
-        void SendPEDecision(struct Parameter pList[], struct CE_Info *ce_info, \
+        void SendPEDecision(struct Parameter pList[], struct Radio_Info *radio_info, \
                 int32_t decision_array[]);
 
Index: vtcross/trunk/src/include/vtcross/containers.h
===================================================================
--- vtcross/trunk/src/include/vtcross/containers.h	(revision 187)
+++ vtcross/trunk/src/include/vtcross/containers.h	(revision 195)
@@ -21,5 +21,5 @@
  *
  */
-struct CE_Info {
+struct Radio_Info {
     uint32_t numUtilities;
     uint32_t numParameters;
Index: vtcross/trunk/src/lib/socketcomm/socketcomm.cpp
===================================================================
--- vtcross/trunk/src/lib/socketcomm/socketcomm.cpp	(revision 190)
+++ vtcross/trunk/src/lib/socketcomm/socketcomm.cpp	(revision 195)
@@ -28,4 +28,7 @@
 // TODO can someone write a description of how this function is operating? I'm
 // not sure I understand why it is making two separate blocking calls to recv
+//
+// TODO also, it appears that this function can, at maximum, receive 256 bytes
+// without causing a buffer overflow. can someone confirm/deny?
 void
 ReadMessage(int32_t socketFD, char* msgBuffer)
@@ -123,5 +126,5 @@
 int32_t 
 GetParameter(int32_t socketFD, struct Parameter pList[], \
-        struct CE_Info *ce_info)
+        struct Radio_Info *radio_info)
 {
     char buffer[256];
@@ -129,9 +132,9 @@
 
     ReadMessage(socketFD, buffer);
-    ce_info->numParameters = atoi(buffer);
+    radio_info->numParameters = atoi(buffer);
     LOG("socket_comm::GetParameter - Number of parameters: %d\n", \
-            ce_info->numParameters);
-    
-    for(size_t i = 0; i < ce_info->numParameters; i++) {
+            radio_info->numParameters);
+    
+    for(size_t i = 0; i < radio_info->numParameters; i++) {
         memset(buffer, 0, 256);
         ReadMessage(socketFD, buffer);
@@ -172,5 +175,5 @@
 // instead of an entire 32 bit integer?  Seems wasteful.
 int32_t 
-GetRequest(int32_t socketFD, struct Parameter pList[], struct CE_Info *ce_info)
+GetRequest(int32_t socketFD, struct Parameter pList[], struct Radio_Info *radio_info)
 {
     char buffer[256];
@@ -185,5 +188,5 @@
 
     LOG("socket_comm::GetRequest - Getting parameters.\n\n");
-    GetParameter(socketFD, pList, ce_info);
+    GetParameter(socketFD, pList, radio_info);
 
     return 1;
Index: vtcross/trunk/src/policy_engines/PolicyEngine.cpp
===================================================================
--- vtcross/trunk/src/policy_engines/PolicyEngine.cpp	(revision 194)
+++ vtcross/trunk/src/policy_engines/PolicyEngine.cpp	(revision 195)
@@ -230,9 +230,9 @@
 void 
 PolicyEngine::SendPEDecision(struct Parameter pList[], \
-        struct CE_Info *ce_info, int32_t decision_array[])
+        struct Radio_Info *radio_info, int32_t decision_array[])
 {
     char var[50];
  
-    for (size_t i = 0; i < ce_info->numParameters; i++) {
+    for (size_t i = 0; i < radio_info->numParameters; i++) {
         sprintf(var, "%i", decision_array[i]);
         SendMessage(commandSocketFD, var);
@@ -248,13 +248,13 @@
     int32_t decision_array[10];
     struct Parameter pList[10];
-    struct CE_Info ce_info;
-
-    if(GetRequest(commandSocketFD, pList, &ce_info)) {
+    struct Radio_Info radio_info;
+
+    if(GetRequest(commandSocketFD, pList, &radio_info)) {
         LOG("Policy Engine:: Validating Transmission Parameters.\n");
-        for (size_t i = 0; i < ce_info.numParameters; i++)
+        for (size_t i = 0; i < radio_info.numParameters; i++)
             decision_array[i] = 1;
 
         LOG("Policy Engine:: Sending Policy decision to Server.\n");
-        SendPEDecision(pList, &ce_info, decision_array);
+        SendPEDecision(pList, &radio_info, decision_array);
 
         LOG("Policy Engine:: Policies Validated.\n");
Index: vtcross/trunk/src/shell/cr_shell.cpp
===================================================================
--- vtcross/trunk/src/shell/cr_shell.cpp	(revision 181)
+++ vtcross/trunk/src/shell/cr_shell.cpp	(revision 195)
@@ -40,7 +40,7 @@
 void 
 print_current_config(Utility* uList[], Parameter* pList[], \
-        Observable* oList[], CE_Info* ce_info)
-{
-	for(size_t i = 0; i < ce_info->numUtilities ; i++) {
+        Observable* oList[], Radio_Info* radio_info)
+{
+	for(size_t i = 0; i < radio_info->numUtilities ; i++) {
         LOG("Shell:: Utility: %s\n\tUnits: %s\n\tGoal: %s\n\tTarget: %f\n", \
                 uList[i]->name.c_str(), uList[i]->units.c_str(), \
@@ -48,5 +48,5 @@
 	}
 
-	for(size_t i = 0; i < ce_info->numParameters; i++) {
+	for(size_t i = 0; i < radio_info->numParameters; i++) {
 	    LOG("Shell:: Radio Operation Profile has been sucessfully sent.\n");
         LOG("Shell:: Parameter: %s\n\tUnits: %s\n\tMin: %f\n\t", \
@@ -61,5 +61,5 @@
 	}
 	
-    for(size_t i = 0; i < ce_info->numObservables; i++) {
+    for(size_t i = 0; i < radio_info->numObservables; i++) {
 		LOG("Observable: %s\n", oList[i]->name.c_str());
 
@@ -79,5 +79,5 @@
 int32_t
 parse_ce_config(TiXmlDocument* doc, Utility* u[], Parameter* p[], \
-        Observable* o[], CE_Info* ce_info)
+        Observable* o[], Radio_Info* radio_info)
 {
 
@@ -128,6 +128,6 @@
 	}
 
-	ce_info->numUtilities = item_count;	
-	LOG("Initialize:: Parsed %d utilities.\n", ce_info->numUtilities);
+	radio_info->numUtilities = item_count;	
+	LOG("Initialize:: Parsed %d utilities.\n", radio_info->numUtilities);
 
 	item_count = 0;
@@ -176,6 +176,6 @@
 	}
 
-	ce_info->numObservables = item_count;	
-	LOG("Initialize:: Parsed %d observables.\n", ce_info->numObservables);
+	radio_info->numObservables = item_count;	
+	LOG("Initialize:: Parsed %d observables.\n", radio_info->numObservables);
 
 	pElem = hRoot.FirstChild("parameters").Element();
@@ -240,6 +240,6 @@
 	}
 
-	ce_info->numParameters = item_count;
-	LOG("Initialize:: Parsed %d parameters.\n", ce_info->numParameters);
+	radio_info->numParameters = item_count;
+	LOG("Initialize:: Parsed %d parameters.\n", radio_info->numParameters);
 
 	return 1;
@@ -249,5 +249,5 @@
 void 
 LoadCEConfiguration(int32_t socketfd,Utility* uList[], Parameter* pList[], \
-        Observable* oList[], CE_Info* ce_info)
+        Observable* oList[], Radio_Info* radio_info)
 {
 	int32_t n,i,j;
@@ -260,8 +260,8 @@
  	// utilities
 	// Send number of utilities
-	sprintf(counter,"%d",ce_info->numUtilities);
+	sprintf(counter,"%d",radio_info->numUtilities);
 	SendMessage(socketfd,counter);
 	// send utility	
-    for(i = 0; i < ce_info->numUtilities; i++) {
+    for(i = 0; i < radio_info->numUtilities; i++) {
 		SendMessage(socketfd, uList[i]->name.c_str());
 		SendMessage(socketfd, uList[i]->units.c_str());
@@ -272,7 +272,7 @@
 
 	// parameters
-    sprintf(counter,"%i",ce_info->numParameters);
+    sprintf(counter,"%i",radio_info->numParameters);
 	SendMessage(socketfd,counter);
-	for(i = 0; i < ce_info->numParameters; i++) {
+	for(i = 0; i < radio_info->numParameters; i++) {
 		SendMessage(socketfd,pList[i]->name.c_str());
 		SendMessage(socketfd,pList[i]->units.c_str());
@@ -293,7 +293,7 @@
 
     // observables
-	sprintf(counter,"%i",ce_info->numObservables);
+	sprintf(counter,"%i",radio_info->numObservables);
 	SendMessage(socketfd,counter);
-	for(i = 0; i < ce_info->numObservables; i++) {
+	for(i = 0; i < radio_info->numObservables; i++) {
 		SendMessage(socketfd,oList[i]->name.c_str());
 		
@@ -351,5 +351,5 @@
 
 int32_t 
-RequestPolicyValidation(Parameter * pList[], CE_Info *ce_info)
+RequestPolicyValidation(Parameter * pList[], Radio_Info *radio_info)
 {
 	char counter[55];
@@ -358,5 +358,5 @@
     char* control_msg = "val";
     
-    int32_t socketfd = ce_info->policy_socket;
+    int32_t socketfd = radio_info->policy_socket;
 
     // Control message that validation request is coming
@@ -366,7 +366,7 @@
 
 	// Send parameter information 
-    sprintf(counter,"%i",ce_info->numParameters);
+    sprintf(counter,"%i",radio_info->numParameters);
 	SendMessage(socketfd,counter);
-	for(i = 0; i < ce_info->numParameters; i++) {
+	for(i = 0; i < radio_info->numParameters; i++) {
 		SendMessage(socketfd,pList[i]->name.c_str());
 		SendMessage(socketfd,pList[i]->units.c_str());
@@ -389,5 +389,5 @@
 RequestCEOptimization(int32_t sockfd, Utility *uList[], 
         Parameter *pList[], Observable *oList[],
-        CE_Info *ce_info)
+        Radio_Info *radio_info)
 {
     char buffer[256];
@@ -398,5 +398,5 @@
     /*
     SendMessage(sockfd,"request"); 
-    for (i = 0; i < ce_info->numObservables; i++){
+    for (i = 0; i < radio_info->numObservables; i++){
         SendMessage(sockfd,..);
     }
@@ -404,5 +404,5 @@
 
     // Receive optimized values from the Cognitive Engine 
-    for (i = 0; i < ce_info->numParameters; i++){
+    for (i = 0; i < radio_info->numParameters; i++){
         bzero(buffer,256);
         ReadMessage(sockfd,buffer);
@@ -413,9 +413,9 @@
 
     // If policy engine is connect, validate new values
-    if(ce_info->policy_engine == 1) {
+    if(radio_info->policy_engine == 1) {
 
         printf("Cognitive Radio:: Found Policy Engine!\n");
         printf("Cognitive Radio:: Validating parameters with Policy Engine\n\n");
-        RequestPolicyValidation(pList,ce_info); 
+        RequestPolicyValidation(pList,radio_info); 
         printf("Cognitive Radio:: Done\n\n");
 
@@ -429,5 +429,5 @@
 RunSimulator(int32_t socketfd, Utility * uList[], 
         Parameter * pList[], Observable * oList[], 
-        CE_Info * ce_info) {
+        Radio_Info * radio_info) {
 	
 	float **past_exp;
@@ -435,5 +435,5 @@
 
 	// Set fake current environment params = current environment
-	RequestCEOptimization(socketfd, uList, pList, oList, ce_info);
+	RequestCEOptimization(socketfd, uList, pList, oList, radio_info);
 
 	// Act like we are updating the hardware tranmission settings
@@ -446,10 +446,10 @@
 
 void 
-InitializePE(int32_t socket, CE_Info * ce_info) 
+InitializePE(int32_t socket, Radio_Info * radio_info) 
 {
     // Policy Engine is connected
     // Set global policy engine value to 1
-    ce_info->policy_engine = 1;
-    ce_info->policy_socket = socket;
+    radio_info->policy_engine = 1;
+    radio_info->policy_socket = socket;
 
     return;
@@ -458,7 +458,7 @@
 void 
 InitializeCE(int32_t socketfd, Utility* uList[], Parameter* pList[], \
-        Observable* oList[], CE_Info* ce_info) 
-{
-	LoadCEConfiguration(socketfd, uList, pList, oList, ce_info);
+        Observable* oList[], Radio_Info* radio_info) 
+{
+	LoadCEConfiguration(socketfd, uList, pList, oList, radio_info);
 	
     // cr experience
@@ -466,6 +466,6 @@
 	int32_t num_cols;
     // get number of columns
-    num_cols = ce_info->numUtilities + ce_info->numParameters;
-    num_cols = num_cols + ce_info->numObservables;
+    num_cols = radio_info->numUtilities + radio_info->numParameters;
+    num_cols = num_cols + radio_info->numObservables;
     num_cols = num_cols + 1;    // overall utility
     int32_t num_rows = 2;
@@ -496,5 +496,5 @@
     UpdateCEExperience(socketfd, num_rows, num_cols, past_exp);	
 
-	RunSimulator(socketfd, uList, pList, oList, ce_info);
+	RunSimulator(socketfd, uList, pList, oList, radio_info);
 }
 
@@ -502,5 +502,5 @@
 void 
 HandleTCPClient(int32_t socketFD, Utility* uList[], Parameter* pList[], \
-        Observable* oList[], CE_Info* ce_info) 
+        Observable* oList[], Radio_Info* radio_info) 
 {
     char buffer[256];
@@ -513,11 +513,11 @@
 
     if(strcmp(buffer,"register_engine_cognitive") == 0) 
-	    InitializeCE(socketFD, uList, pList, oList, ce_info);
+	    InitializeCE(socketFD, uList, pList, oList, radio_info);
 
     if(strcmp(buffer,"register_engine_policy") == 0)
-	    InitializePE(socketFD, ce_info);
+	    InitializePE(socketFD, radio_info);
 
     if(strcmp(buffer,"optimize") == 0)
-	    RunSimulator(socketFD, uList, pList, oList, ce_info);
+	    RunSimulator(socketFD, uList, pList, oList, radio_info);
         
     // TODO why aren't we doing this anymore?
@@ -528,5 +528,5 @@
 int32_t 
 StartServers(Utility* uList[], Parameter* pList[], Observable* oList[], \
-        CE_Info* ce_info)
+        Radio_Info* radio_info)
 {
     int32_t * servSock; 
@@ -632,5 +632,5 @@
                             }
                             
-                            HandleTCPClient(new_sd, uList, pList, oList, ce_info);
+                            HandleTCPClient(new_sd, uList, pList, oList, radio_info);
                             FD_SET(new_sd,&sockSet);
                             if(new_sd > maxDescriptor) 
@@ -641,5 +641,5 @@
                         
                         printf("Request on already open descriptor.\n\n");
-                        HandleTCPClient(port, uList, pList, oList, ce_info);
+                        HandleTCPClient(port, uList, pList, oList, radio_info);
 
                     }
@@ -671,10 +671,10 @@
 	Parameter * pList[10];
 	Observable * oList[10];
-	struct CE_Info *ce_info;
+	struct Radio_Info *radio_info;
 
     if((fd = open("/dev/zero", O_RDWR)) == -1)
             return 1;
 
-    ce_info = (struct CE_Info *)mmap(0,sizeof(CE_Info),PROT_READ|PROT_WRITE,MAP_SHARED,fd,0);
+    radio_info = (struct Radio_Info *)mmap(0,sizeof(Radio_Info),PROT_READ|PROT_WRITE,MAP_SHARED,fd,0);
 
     close(fd);
@@ -696,10 +696,10 @@
 
 	cout << "\n\nInitialize:: Attemping to parse " << pFilename << "." << endl;
-	parse_ce_config( &doc , uList, pList, oList, ce_info);
+	parse_ce_config( &doc , uList, pList, oList, radio_info);
 	cout << "Initialize:: Configuration file parsing completed.\n" << endl;
 
-    //print_current_config(uList, pList, oList, &ce_info);
+    //print_current_config(uList, pList, oList, &radio_info);
 	
-   StartServers(uList, pList, oList, ce_info);
+   StartServers(uList, pList, oList, radio_info);
    return 1;
 }