Index: vtcross/trunk/src/include/vtcross/components.h
===================================================================
--- vtcross/trunk/src/include/vtcross/components.h	(revision 208)
+++ vtcross/trunk/src/include/vtcross/components.h	(revision 209)
@@ -49,5 +49,4 @@
         }
 
-        
         /* Send an indentfying string for this object's component type in
          * response to a GetRemoteComponentType query.
@@ -55,14 +54,11 @@
         virtual void SendComponentType() = 0;
 
-
         /* Wait for a command signal containing task instructions.
          */
         virtual void WaitForSignal() = 0;
 
-
         /* Completely shutdown the radio and all operations.
          */
         virtual void Shutdown() = 0;
-
 
         /* Reset the radio and reload all configuration files.
@@ -71,5 +67,4 @@
          */
         virtual void Reset() = 0;
-
 
         /* Register or deregister a component with the primary radio shell.
@@ -97,5 +92,4 @@
                 const char* serverPort, const bool SML) = 0;
 
-
         /* Register or deregister services that this engine provides with the
          * service management layer.
@@ -140,10 +134,8 @@
         void TransferRadioConfiguration();
 
-        
         /* Receive information regarding a completed 'experience' and pass it on
          * to the appropriate cognitive engine.
          */
         void TransferExperience();
-
         
         /* Listen for other components registering their available services with
@@ -152,5 +144,4 @@
         void ReceiveServices();
 
-
         /* Change the active mission of the radio to a new one and adjust radio
          * behavoir appropriately.
@@ -158,9 +149,7 @@
         void SetActiveMission();
 
-
         /* List all services provided to the radio by registered components.
          */
         void ListServices();
-
 
         /* Load/Relead the XML configuration file. 
@@ -169,5 +158,4 @@
         void LoadConfiguration();
 
-
         /* The socket file descriptor information for the shell which this SML
          * is connected to.
@@ -185,5 +173,4 @@
         PolicyEngine();
         ~PolicyEngine();
-
 
         /* Overloaded constructor that creates a policy engine object and
@@ -211,5 +198,4 @@
         void ReloadPolicies();
 
-        
         /* Return a decision made by the policy engine regarding a certain set
          * of transmission parameters.
@@ -218,9 +204,7 @@
                 int32_t decision_array[]);
 
-
         /* Validate a set of transmission parameters received from the radio.
          */
         void ValidateParameters();
-
 
         /* The SML_present bool reflects whether or not the remote component
@@ -261,9 +245,7 @@
         void ReceiveRadioConfiguration();
 
-
         /* Receive an 'experience' report from the radio.
          */
         void ReceiveExperience();
-
 
         /* Find the most optimal set of transmission parameters given certain
@@ -273,5 +255,4 @@
         void GetSolution(Observable *observables);
         void GetSolution(Observable *observables, std::string service);
-
 
         /* Receive a feedback from the radio regarding the performance of a
@@ -303,6 +284,7 @@
         ~CognitiveRadioShell();
 
-
-        /* Overloaded constructor that creates a CR Shell object */ 
+        /* Overloaded constructor that creates a CR Shell object and loads the
+         * passed radio configuration XML file.
+         */
         CognitiveRadioShell(const char* radioConfig, int16_t primaryPort, \
             int16_t policyPort, int16_t commandPort);
@@ -314,4 +296,5 @@
         /* Start all the socket servers */
         void StartShellServer();
+
         int32_t LoadRadioConfiguration(const char* radioConfig, Parameter* &pList, \
             Utility* &uList, Observable* &oList, Radio_Info* radioInfo);
@@ -322,5 +305,6 @@
         void ReloadPolicies();
 
-        /* Register and Deregister the different components */
+        /* Register and Deregister the different components.
+         */
         void RegisterCognitiveEngine(int32_t socketFD);
         void DeregisterCognitiveEngine(int32_t socketFD);
@@ -330,8 +314,10 @@
         void DeregisterSML(int32_t socketFD);
 
-        /* Handle a message that is received from a component */
+        /* Handle a message that is received from a component.
+         */
         void HandleMessage(int32_t socketFD);
        
-        /* Send optimization request to primary port FD*/
+        /* Send optimization request to primary port FD.
+         */
         void GetOptimalParameters(int32_t socketFD);
 